#!/usr/bin/perl

use strict;
use Cwd 'chdir';

my $tempwarning = "23";
my $tempcritical = "27";

my $timestamp = localtime(time);

my $status = "OK";
my @tempargs;
my $digitemp;
my $tempargs;
my $currenttemp;
my $exitval=0;

sub check_temp()
{
	chdir("/usr/local/nagios");
	$digitemp=`/usr/local/bin/digitemp -t0 -q`;
	chomp($digitemp);
	#Format of $digitemp is Feb 12 11:40:21 Sensor 0 C: 23.01 F: 73.42
	@tempargs=split(" ",$digitemp); #Split on spaces
	#print $digitemp;
	#print $tempargs[6];
	if (!($tempargs[6]))
	{
		$status="UNKNOWN";
		$exitval=3;
		print "TEMP $status - [ $digitemp ]\n";	
		exit $exitval;
	}
	$currenttemp=$tempargs[6];
}

sub test_result()
{
	if ($currenttemp>=$tempcritical)
	{
		#print "Temperature Critical, $currenttemp C\n";
		$status="CRITICAL";
		$exitval=2;
	}
	elsif ($currenttemp>=$tempwarning)
	{
		#print "Temperature Warning, $currenttemp C\n";
		$status="WARNING";
		$exitval=1;
	}

}

sub report_result()
{
	print "TEMP $status - [ $currenttemp C at $digitemp ]\n";	
	exit $exitval;
}

if (-e "/usr/local/nagios/.digitemprc") 
{
	&check_temp;
	&test_result;
	&report_result;
}
else
{
	$status="UNKNOWN";
	$exitval=3;
	print "TEMP $status - [ File .digitemprc not found or unreadable ]\n";	
	exit $exitval;
}
